/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


/* ###--------------------------------------------------------------### */
/* file		: dlx_yacc.h						*/
/* date		: Apr 20 1995						*/
/* version	: v0.4							*/
/* author	: Pirouz BAZARGAN SABET					*/
/* description	: DLX assembler - external, global and static variables	*/
/* ###--------------------------------------------------------------### */

extern int                DLX_ARCHIT       ; 
extern int                DLX_LINNUM       ; 

static int                DLX_PASNBR       ;
static int                DLX_ERRFLG       ;

static FILE              *DLX_TXTFIL = NULL;
static unsigned long      DLX_TXTADR = 0   ;
static int                DLX_TXTSIZ = 0   ;

static FILE              *DLX_DATFIL = NULL;
static unsigned long      DLX_DATADR = 0   ;
static int                DLX_DATSIZ = 0   ;

static char              *DLX_LABEL  = NULL;

static FILE              *DLX_WRTFIL = NULL;
static FILE              *DLX_SYMFIL = NULL;

static unsigned long      DLX_ADDRES       ;
static int                DLX_ADRSIZ = 0   ;
static int                DLX_WRDSIZ = 0   ;
static char               DLX_ADRSPC = 'T' ;
static char               DLX_SYMBOL = 'n' ;

static unsigned char      DLX_BYTTAB [1024];

static struct beden     **DLX_HSHTAB = NULL;

static void               dlx_error    ();
static void               dlx_head     ();
static void               dlx_foot     ();
static void               dlx_print    ();
static void               dlx_symbol   ();
static int                dlx_strtobin ();
