#include "C4_lofig.h"

/************************************************************************/
/*	Fonction C4_netlist_put_in() 					*/
/************************************************************************/
void 
C4_netlist_put_in (lofig_list * LOFIG, char *c, losig_list * grille, 
	losig_list * drain, losig_list * source, char type)
{
  char *trname;
  lotrs_list *TRANSISTOR;
  losig_list *bulk;
  if (type == TRANSP)
    bulk = getlosig (LOFIG, 2);
  else
    bulk = getlosig (LOFIG, 3);
  trname = malloc ((strlen (c) + 4) * sizeof (char));
  if (type == TRANSP)
    strcpy (trname, "TP_");
  else
    strcpy (trname, "TN_");
  strcat (trname, c);
  if (type ==TRANSP)
       TRANSISTOR = addlotrs (LOFIG, type, 0, 0, 20, 1, 0, 0, 0, 0, 
	grille, source, drain, bulk, trname);
  else
       TRANSISTOR = addlotrs (LOFIG, type, 0, 0, 10, 1, 0, 0, 0, 0, 
	grille, source, drain, bulk, trname);
}


/************************************************************************/
/*	Fonction C4_netlist_createN()					*/
/************************************************************************/
int 
C4_netlist_createN (lofig_list * LOFIG, long index, chain_list * abl, 
			losig_list * down, losig_list * up)
{
  char *signame;
  chain_list *c;
  losig_list *int_sig;
  int flag;
  if (ABL_ATOM (abl))
    {
      if (strcmp (ABL_ATOM_VALUE (abl), C4_FICTIVE))
	{
	  index++;
	  int_sig = addlosig (LOFIG, index, 
			addchain (NULL, ABL_ATOM_VALUE (abl)), EXTERNAL);
	  addlocon (LOFIG, ABL_ATOM_VALUE (abl), int_sig, IN);
	  C4_netlist_put_in (LOFIG, ABL_ATOM_VALUE (abl), 
				int_sig, down, up, TRANSN);
	}
    }
  else
    {
      if (ABL_OPER (abl) == ABL_OR)
	{
	  flag = 1;
	  for (c = ABL_CDR (abl); c ; c = ABL_CDR (c)) {
	    if (strcmp (ABL_ATOM_VALUE (ABL_CAR (c)), C4_FICTIVE))
	      {
		if (flag == 1)
		  index = C4_netlist_createN (LOFIG, index, ABL_CAR (c), 
						down, up);
		else
		  index = C4_netlist_createN (LOFIG, index, ABL_CAR (c), 
						up, down);
	      }
	    flag = - flag;
	  }
	}

      if (ABL_OPER (abl) == ABL_AND)
	{
	  for (c = ABL_CDR (abl); c; c = ABL_CDR (c))
	    if (strcmp (ABL_ATOM_VALUE (ABL_CAR (c)), C4_FICTIVE))
	      {
		if ((ABL_CDR (c)) && 
			(strcmp (ABL_ATOM_VALUE (ABL_CADR (c)), C4_FICTIVE)))
		  {
		    index++;
		    signame = malloc (20 * sizeof (char));
		    sprintf (signame, "aux%d", index);
		    int_sig = addlosig (LOFIG, index, 
				addchain (NULL, signame), INTERNAL);
		    index = C4_netlist_createN (LOFIG, index, ABL_CAR (c), 
						int_sig, up);
		    up = int_sig;
		  }
		else
		  index = C4_netlist_createN (LOFIG, index, ABL_CAR (c), 
						down, up);
	      }
	}
    }
  return index;
}

/************************************************************************/
/*	Fonction C4_netlist_createP()					*/
/************************************************************************/
int 
C4_netlist_createP (lofig_list * LOFIG, long index, chain_list * abl, 
			losig_list * down, losig_list * up)
{
  char *signame;
  chain_list *c;
  losig_list *int_sig;
  int flag;
  if (ABL_ATOM (abl))
    {
      if (strcmp (ABL_ATOM_VALUE (abl), C4_FICTIVE))
	C4_netlist_put_in (LOFIG, ABL_ATOM_VALUE (abl), 
	(getlocon (LOFIG, ABL_ATOM_VALUE (abl)))->SIG, down, up, TRANSP);

    }
  else
    {
      if (ABL_OPER (abl) == ABL_AND)
	{
	  flag = 1;
	  for (c = ABL_CDR (abl); c ; c = ABL_CDR (c)) {
	    if (strcmp (ABL_ATOM_VALUE (ABL_CAR (c)), C4_FICTIVE))
	      {
		if (flag == 1)
		  index = C4_netlist_createP (LOFIG, index, ABL_CAR (c), 
						down, up);
		else
		  index = C4_netlist_createP (LOFIG, index, ABL_CAR (c), 
						up, down);
	      }
	    flag = - flag;
	  }
	}

      if (ABL_OPER (abl) == ABL_OR)
	{
	  for (c = ABL_CDR (abl); c; c = ABL_CDR (c))
	    if (strcmp (ABL_ATOM_VALUE (ABL_CAR (c)), C4_FICTIVE))
	      {
		if ((ABL_CDR (c)) && 
			(strcmp (ABL_ATOM_VALUE (ABL_CADR (c)), C4_FICTIVE)))
		  {
		    index++;
		    signame = malloc (20 * sizeof (char));
		    sprintf (signame, "aux%d", index);
		    int_sig = addlosig (LOFIG, index, 
				addchain (NULL, signame), INTERNAL);
		    index = C4_netlist_createP (LOFIG, index, ABL_CAR (c), 
						down, int_sig);
		    down = int_sig;
		  }
		else
		  index = C4_netlist_createP (LOFIG, index, ABL_CAR (c), 
						down, up);
	      }
	}
    }
  return index;
}

/************************************************************************/
/*	Fonction C4_netlist()                 				*/
/*									*/
/*	Par convention le signal VDD a l'index 2,			*/
/*	le signal VSS a l'index 3 et le signal de sortie l'index 1	*/
/*	Il faut ajouter les transistors du buffer			*/
/************************************************************************/
lofig_list *
C4_netlist (befig_list * BEFIG,int buffer)
{
  lofig_list *LOFIG;
  long index;
  losig_list *sigvdd, *sigvss, *sigout;


  LOFIG = addlofig (BEFIG->NAME);

  sigout = addlosig (LOFIG, 1, addchain (NULL, BEFIG->BEOUT->NAME), EXTERNAL);
  addlocon (LOFIG,BEFIG->BEOUT->NAME,sigout,IN);

  sigvdd = addlosig (LOFIG, 2, addchain (NULL, "vdd"), EXTERNAL);
  addlocon (LOFIG, "vdd", sigvdd, IN);

  sigvss = addlosig (LOFIG, 3, addchain (NULL, "vss"), EXTERNAL);
  addlocon (LOFIG, "vss", sigvss, IN);

  if (buffer ==1) {
      index = C4_netlist_createN(LOFIG,3,ABL_CADR((BEFIG->BEOUT->ABL)), 
		sigvss, sigout);
       C4_netlist_createP(LOFIG,index,ABL_CADR(BEFIG->BEOUT->ABL), 
		sigout, sigvdd);
      }
  else { 
	index = C4_netlist_createN(LOFIG,3,BEFIG->BEOUT->ABL, 
		sigvss, sigout);
	C4_netlist_createP(LOFIG,index,BEFIG->BEOUT->ABL, 
		sigout, sigvdd);
      }
  return (LOFIG);
}

/************************************************************************/
/*	Fonctions auxiliaires pour C4_ordonne()				*/
/************************************************************************/
ablexpr *
C4_ordonne_addablexpr (ablexpr * abl, ablexpr * data)
{
  ablexpr *a;
  a = malloc (sizeof *a);
  a->NEXT = abl;
  a->DATA = data;
  return a;
}

ablexpr *
C4_ordonne_aboute (ablexpr * g, ablexpr * d)
{
  if (g)
    {
      ablexpr *pt = (g);
      while (pt->NEXT)
	pt = pt->NEXT;
      pt->NEXT = d;
      return (g);
    }
  else
    return (d);
}

/************************************************************************/
/*	Fonction C4_ordonne()						*/
/************************************************************************/
int 
C4_ordonne (ablexpr * ABL, int DIRECTION)
{
  int d, etat;
  ablexpr *pt, *un, *deux, *zero, *gauche, *droite;

  un = NULL;
  deux = NULL;
  zero = NULL;
  gauche = NULL;
  droite = NULL;
  d = DIRECTION;
  if ABL_ATOM
    (ABL) return 0;
  pt = ABL;
  while (ABL_CDR (pt))
    {
      pt = ABL_CDR (pt);
      etat = C4_ordonne (ABL_CAR (pt), d);
      if (etat == 0)
	zero = C4_ordonne_addablexpr (zero, ABL_CAR (pt));
      if (etat == 2)
	deux = C4_ordonne_addablexpr (deux, ABL_CAR (pt));
      if (etat == 1)
	{
	  un = C4_ordonne_addablexpr (un, ABL_CAR (pt));
	  d = -d;
	}
    }
  if (DIRECTION == C4_VINCENT_GAUCHE)
    {
      if ((un) && (d == C4_VINCENT_GAUCHE))
	{
	  droite = C4_ordonne_addablexpr (droite, ABL_CAR (un));
	  un = un->NEXT;
	}
      pt = un;
      while (pt)
	{
	  gauche = C4_ordonne_addablexpr (gauche, ABL_CAR (pt));
	  pt = pt->NEXT;
	}
      gauche = C4_ordonne_aboute (deux, gauche);
    }
  if (DIRECTION == C4_VINCENT_DROITE)
    {
      droite = deux;
      if ((un) && (d == C4_VINCENT_DROITE))
	{
	  droite = C4_ordonne_aboute (un->NEXT, droite);
	  gauche = un;
	  gauche->NEXT = NULL;
	}
      else
	droite = C4_ordonne_aboute (un, droite);
    }
  ABL_CDR (ABL) = C4_ordonne_aboute (gauche, C4_ordonne_aboute (zero, droite));

  if (getablexprlength (ABL) % 2)
    {
      if ((gauche) && (droite))
	return 2;
      if ((gauche) || (droite))
	return 1;
      return 0;
    }
  else
    {
      if (DIRECTION == C4_VINCENT_GAUCHE)
	addablhexpr (ABL, createablatom (C4_FICTIVE));
      else
	addablqexpr (ABL, createablatom (C4_FICTIVE));
      if ((gauche) && (droite))
	return 2;
      return 1;
    }
}

/************************************************************************/
/*	Fonction C4_lofig()						*/
/************************************************************************/
lofig_list *
C4_lofig (befig_list * BEFIG,int buffer)
{
lofig_list *LOFIG;

flatablexpr(BEFIG->BEOUT->ABL);  // pour eviter les (or(or(...)))

if (buffer==1) C4_ordonne(ABL_CADR(BEFIG->BEOUT->ABL), C4_VINCENT_GAUCHE);
else           C4_ordonne (BEFIG->BEOUT->ABL, C4_VINCENT_GAUCHE);

LOFIG=C4_netlist(BEFIG,buffer);
return (LOFIG);
}
