#ifndef __C4_topologie_H__
#define __C4_topologie_H__

#ifndef C4_FICTIVE
#define C4_FICTIVE "*"
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include MUT_H
#include AUT_H
#include ABL_H
#include BDD_H
#include ABE_H
#include ABV_H
#include ABT_H

#include MLO_H
#include MLU_H
#include MPH_H

//projete

typedef struct projection_list
  {
    struct projection_list *NEXT;
    char *NOM;
    losig_list *GAUCHE;
    losig_list *DROITE;
  }
projection_list;

projection_list *C4_projection_addprojname (projection_list *, char *name);
projection_list *C4_projection_genproj (projection_list *, ablexpr *);
//void C4_projection_affproj (projection_list * TAB);
projection_list *C4_projection_loadproj (lofig_list *, befig_list *, char TYPE);
int C4_reunit (projection_list *);
projection_list *C4_C4_projection_projete_1 (projection_list *);
projection_list *C4_projection_symetrique (projection_list *);
projection_list *C4_projete (lofig_list *, befig_list *, char);

//topologie

#define C4_NBN 4
#define C4_NBP 4
#define C4_NBTOT 9

typedef struct C4_instance
  {
    struct C4_instance *NEXT;
    char *NOM;
    losig_list *SIG[C4_NBTOT];
    int VIA[C4_NBTOT];
    long INDEX;
  }
C4_instance_list;

typedef struct C4_listproj
  {
    struct C4_listproj *NEXT;
    projection_list *DATA;
    C4_instance_list *TOP;
    int TAILLE;
  }
C4_listproj_list;

typedef struct C4_segment
  {
    struct C4_segment *NEXT;
    C4_instance_list *REF1;
    int INDEX1;
    C4_instance_list *REF2;
    int INDEX2;
    losig_list *SIG;
  }
C4_segment_list;

typedef struct C4_fig
  {
    C4_instance_list *INS;
    C4_segment_list *SEG;
    char *NOM;
    char *SORTIE;
  }
C4_fig_route;

C4_listproj_list *C4_topo_addlistproj (C4_listproj_list *, projection_list *, C4_instance_list * TOPO);

C4_listproj_list *C4_topo_loadlistproj (projection_list *, C4_instance_list *);

int C4_topo_getlen (projection_list *);

C4_instance_list *C4_topo_addinstance (C4_instance_list *, char *);

void C4_topo_afftopo (C4_instance_list * TOPO);

void C4_topo_add_VddVss (C4_instance_list *, projection_list *, projection_list *);

C4_instance_list *C4_topo_loadtopo (projection_list *, projection_list *);

projection_list *C4_topo_extremite_droite (losig_list * SIGNAL, projection_list * EXTREMITE, projection_list * BANDE);

int C4_topo_placeseg (C4_instance_list * TOPO, int RANG, projection_list * BANDE);

C4_instance_list *C4_topo_route (projection_list *, projection_list *, lofig_list *,int);

C4_segment_list *C4_topo_addseg (C4_segment_list * LIST, C4_instance_list * ref1, int index1, C4_instance_list * ref2, int index2, losig_list * sig);

C4_segment_list *C4_topo_genereseg (C4_instance_list * INS, C4_segment_list * SEG);

void C4_fig_affseglist (C4_segment_list * SEG);

void C4_aff_fig (C4_fig_route * FIG);

C4_fig_route *C4_topo (lofig_list * LOFIG, befig_list *);

#endif
