/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_phcma.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef PHCMA_H
#define PHCMA_H

/* Structure contenant les informations sur un CMA ou une
   equipotentielle. */
typedef struct phcma
{
    char           *NAME;       /* nom de l'equipotentielle. */
    char            TYPE;       /* type : CMA ou EQUI.       */
    long            NBREF;      /* nombre de "ref_con".      */
    struct ptype   *PPHREF;     /* liste des "ref_con".      */
    struct phcma_link *LINK;    /* equipotentielles filles.  */
    struct phcma   *NEXT;       /* chainage.                 */
}               phcma_list;

/* Informations sur les equipotentielles filles. */
typedef struct phcma_link
{
    struct phcma_link *NEXT;    /* chainage.                 */
    struct phfig   *PHFIG;      /* modele contenant l'EQUI.  */
    struct phcma   *PHCMA;      /* EQUI concernee du modele. */
    long            XFLAT;      /* transformation de flatten */
    long            YFLAT;      /* specifique au LINK.       */
    char            ATRANSF;
} phcma_link_list;

/* Constantes du module. */
#define        C_PHCMA_CMA         2
#define        C_PHCMA_EQUI        3

/* Fonctions d'interface du module. */
extern void     extract_ls_cma();
extern void     del_ls_cma();
extern void    *dup_ls_cma();
extern long     link_ls_cma();
extern void     extract_ls_cmaref();

#endif                          /* PHCMA_H */
