/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_phcut.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef PHCUT_H
#define PHCUT_H

/* Constantes du module. */
#define        C_PHCUT_REF           1
#define        C_PHCUT_USER          2
#define        C_PHCUT_FREE          3
#define        C_PHCUT_UNKNOW        4


/* Structure contenant les informations sur une ligne de coupe. */
typedef struct phcut
{
    long            YCUT;       /* ordonnee de ligne la coupe.       */
    long            PITCHNB;    /* nombre de transparences ajoutees. */
    struct phcut   *NEXT;
}               phcut_list;


/* Fonctions d'interface du module : */
extern phcut_list *addophcut();
extern phcut_list *dup_ls_phcut();
extern long     cmp_ls_phcut();
extern void     free_ls_phcut();
extern phcut_list *check_ls_phcut();
extern long     ycut_calc();
extern long     ycut_norm();
extern long     ycut_analys();
extern phcut_list *strtocut();

#endif                          /* PHCUT_H */
