/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include MUT_H
#include MLO_H
#include MLU_H
#include MPH_H
#include MPU_H
#include SCR_H
#include "mbkgen.h"
#include "util.h"

void ROUTE_CHANNEL(va_alist)
va_dcl
{
ptype_list *pt = NULL;
va_list args;
channel_list *ch;
char *s;
int i;

	if (WORK_PHFIG == NULL) {
		(void)fflush(stdout);
		(void)fputs("*** genlib error ***\n", stderr);
		(void)fputs("Illegal ROUTE_CHANNEL : missing DEF_PHFIG\n", stderr);
		EXIT(1);
	}
	va_start(arg);
	figname = namealloc(va_arg(arg, char *));
	while (1) {
		
		if (!(s = namealloc(checkname(va_arg(arg, char *)))))
			break;
		if (!(i = ((va_arg(arg, int) + 1) * 2) / 2)) {
			fflush(stdout);
			(void)fputs("*** genlib error ***\n", stderr);
			(void)fputs("Illegal ROUTE_CHANNEL : 0 width supply\n", stderr);
			EXIT(1);
		}
		pt = addptype(pt, i, s);
	}

	lf = getlofig(argv[1], 'A');
	ch = checkandbuild(WORK_PHFIG, lf, pt);
	routechannel(WORK_PHFIG, ch);
	destroysegments(getphfig(ch->NAME, 'A'), null);
	verticalmerge(getphfig(ch->NAME, 'A'));
	makeblock(pf, ch);
}
