/*
 * $Author: ac $
 * $Id: bflerr.c,v 1.2 2000/03/16 11:01:11 ac Exp $
 * $Date: 2000/03/16 11:01:11 $
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __STDC__
#include <stdarg.h>
#else
#include <varargs.h>
#endif
#include BFL_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

#ifdef SunOS

extern char *sys_errlist[];
extern int errno, sys_nerr;

static char *
strerror(nerr)
    int nerr;
{
    if (nerr < sys_nerr)
	return sys_errlist[nerr];
    else
	return "unknown error";
}

#endif

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

void
#ifdef __STDC__
bflsyserror(int eval, const char *fmt,...)
#else
bflsyserror(eval, fmt, va_alist)
    int eval;
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif

    (void) fflush(stdout);
    (void) fprintf(stderr, "%s: ", __progname);
    if (fmt != NULL) {
	(void) vfprintf(stderr, fmt, ap);
	(void) fprintf(stderr, ": ");
    }
    (void) fprintf(stderr, "%s\n", strerror(errno));
    exit(eval);
    va_end(ap);
}

void
#ifdef __STDC__
bflerror(int eval, const char *fmt,...)
#else
bflerror(eval, fmt, va_alist)
    int eval;
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif

    (void) fflush(stdout);
    (void) fprintf(stderr, "%s: ", __progname);
    if (fmt != NULL)
	(void) vfprintf(stderr, fmt, ap);
    (void) fprintf(stderr, "\n");
    exit(eval);
    va_end(ap);
}

void
#ifdef __STDC__
bflsyswarning(const char *fmt,...)
#else
bflsyswarning(fmt, va_alist)
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif

    (void) fflush(stdout);
    (void) fprintf(stderr, "%s: ", __progname);
    if (fmt != NULL) {
	(void) vfprintf(stderr, fmt, ap);
	(void) fprintf(stderr, ": ");
    }
    (void) fprintf(stderr, "%s\n", strerror(errno));
    va_end(ap);
}

void
#ifdef __STDC__
bflwarning(const char *fmt,...)
#else
bflwarning(fmt, va_alist)
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif

    (void) fflush(stdout);
    (void) fprintf(stderr, "%s: ", __progname);
    if (fmt != NULL)
	(void) vfprintf(stderr, fmt, ap);
    (void) fprintf(stderr, "\n");
    va_end(ap);
}

void
#ifdef __STDC__
bflmessage(const char *fmt,...)
#else
bflmessage(fmt, va_alist)
    char *fmt;
    va_dcl

#endif
{
    va_list ap;

#ifdef __STDC__
    va_start(ap, fmt);
#else
    va_start(ap);
#endif

    (void) fflush(stderr);
    (void) fprintf(stdout, "%s: ", __progname);
    if (fmt != NULL)
	(void) vfprintf(stdout, fmt, ap);
    (void) fprintf(stderr, "\n");
    va_end(ap);
}
