/*
 * $Author: ac $
 * $Id: butunvector.c,v 1.2 1999/10/21 12:52:01 ac Exp $
 * $Date: 1999/10/21 12:52:01 $
 */
/*
 * $Log: butunvector.c,v $
 * Revision 1.2  1999/10/21 12:52:01  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:39  alliance
 * fpmap import
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  BDD_H
#include  ABE_H
#include  BUT_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*              void but_unvector_bereg( befig_list *BehFigure )              */
/* -------------------------------------------------------------------- */
/*  Devectorise tous les registres de BehFigure.				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*	Aucun								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_bereg( befig_list * BehFigure )
{
	bereg_list *bereg;
	char *new_name;

	for ( bereg = BehFigure->BEREG; bereg != 0; bereg = bereg->NEXT )
		if ( strchr( bereg->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( bereg->NAME );
			but_substname( BehFigure, bereg->NAME, new_name );
			bereg->NAME = new_name;
		}
}

/*----------------------------------------------------------------------*/
/*              void but_unvector_berin( befig_list * BehFigure )             */
/* -------------------------------------------------------------------- */
/*  Devectorise toutes les entrees de BehFigure.				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_berin( befig_list * BehFigure )
{
	berin_list *berin;
	char *new_name;

	for ( berin = BehFigure->BERIN; berin != 0; berin = berin->NEXT )
		if ( strchr( berin->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( berin->NAME );
			but_substname( BehFigure, berin->NAME, new_name );
		}
}

/*----------------------------------------------------------------------*/
/*              void but_unvector_beout( befig_list * BehFigure )             */
/* -------------------------------------------------------------------- */
/*  Devectorise toutes les sorties de BehFigure.				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_beout( befig_list * BehFigure )
{
	beout_list *beout;
	char *new_name;

	for ( beout = BehFigure->BEOUT; beout != 0; beout = beout->NEXT )
		if ( strchr( beout->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( beout->NAME );
			but_substname( BehFigure, beout->NAME, new_name );
			beout->NAME = new_name;
		}
}

/*----------------------------------------------------------------------*/
/*              void but_unvector_bebus( befig_list * BehFigure )             */
/* -------------------------------------------------------------------- */
/*  Devectorise tous les bus externes de BehFigure.				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_bebus( befig_list * BehFigure )
{
	bebus_list *bebus;
	char *new_name;

	for ( bebus = BehFigure->BEBUS; bebus != 0; bebus = bebus->NEXT )
		if ( strchr( bebus->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( bebus->NAME );
			but_substname( BehFigure, bebus->NAME, new_name );
			bebus->NAME = new_name;
		}
}

/*----------------------------------------------------------------------*/
/*              void but_unvector_beaux( befig_list *BehFigure )              */
/* -------------------------------------------------------------------- */
/*  Devectorise tous les auxiliaires de BehFigure.				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*	Aucun.								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_beaux( befig_list * BehFigure )
{
	beaux_list *beaux;
	char *new_name;

	for ( beaux = BehFigure->BEAUX; beaux != 0; beaux = beaux->NEXT )
		if ( strchr( beaux->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( beaux->NAME );
			but_substname( BehFigure, beaux->NAME, new_name );
			beaux->NAME = new_name;
		}
}

/*----------------------------------------------------------------------*/
/*           void but_unvector_bebux( befig_list *BehFigure )           */
/* -------------------------------------------------------------------- */
/*  Devectorise tous les bus internes de BehFigure.			*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

static void
but_unvector_bebux( befig_list * BehFigure )
{
	bebux_list *bebux;
	char *new_name;

	for ( bebux = BehFigure->BEBUX; bebux != 0; bebux = bebux->NEXT )
		if ( strchr( bebux->NAME, ' ' ) != 0 ) {
			new_name = but_unvector_name( bebux->NAME );
			but_substname( BehFigure, bebux->NAME, new_name );
			bebux->NAME = new_name;
		}
}

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*               char *but_unvector_name( char *OldName )               */
/* -------------------------------------------------------------------- */
/*  Devectorise un identifier. Par exemple, "toto 0" => "toto_0"	*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

char *
but_unvector_name( char *OldName )
{
	char buf[BUFSIZ];

	strcpy( buf, OldName );
	for ( OldName = buf; *OldName != 0; OldName++ )
		if ( *OldName == ' ' )
			*OldName = '_';
	return namealloc( buf );
}

/*----------------------------------------------------------------------*/
/*         void but_unvector( befig_list *BehFigure, int type )         */
/* -------------------------------------------------------------------- */
/*	Devectorise tous les identifier d'une BehFigure en fonction de	*/
/* type. type est un champ de bit, les valeurs possibles sont:		*/
/*	BUT_BERIN	:						*/
/*	BUT_BEOUT	:						*/
/*	BUT_BEBUS	:						*/
/*	BUT_BEREG	:						*/ 
/*	BUT_BEAUX	:						*/
/*	BUT_BEBUX	:						*/
/*	BUT_ALL		: Tous d'un coup !!				*/
/* -------------------------------------------------------------------- */
/* Parametres:								*/
/* Retours:								*/
/*----------------------------------------------------------------------*/

void
but_unvector( befig_list * BehFigure, int type )
{
	if ( type & BUT_BERIN ) but_unvector_berin( BehFigure );
	if ( type & BUT_BEOUT ) but_unvector_beout( BehFigure );
	if ( type & BUT_BEBUS ) but_unvector_bebus( BehFigure );
	if ( type & BUT_BEREG ) but_unvector_bereg( BehFigure );
	if ( type & BUT_BEAUX ) but_unvector_beaux( BehFigure );
	if ( type & BUT_BEBUX ) but_unvector_bebux( BehFigure );
}

/*----------------------------------------------------------------------*/
/*           void but_substname( BehFigure, OldName, NewName )          */
/* -------------------------------------------------------------------- */
/*	Substitution d'un Identifier par un autre dans tous les abls	*/
/* d'une Befig. Change aussi Befig->BERIN.				*/
/*----------------------------------------------------------------------*/

void
but_substname( befig_list *BehFigure, char *OldName, char *NewName )
{
	berin_list *berin;
	bepor_list *bepor;
	beaux_list *beaux;
	beout_list *beout;
	bebus_list *bebus;
	bereg_list *bereg;
	bebux_list *bebux;
	biabl_list *biabl;
	ablexpr *rep_expr;

	rep_expr = createablatom( NewName );

	for ( berin = BehFigure->BERIN; berin != 0; berin = berin->NEXT )
		if ( berin->NAME == OldName )
			berin->NAME = NewName;

	for ( bepor = BehFigure->BEPOR; bepor != 0; bepor = bepor->NEXT )
		if ( bepor->NAME == OldName )
			bepor->NAME = NewName;

	for ( beaux = BehFigure->BEAUX; beaux != 0; beaux = beaux->NEXT )
		if ( beaux->ABL != 0 )
			beaux->ABL = substablexpr( beaux->ABL, OldName, rep_expr );

	for ( beout = BehFigure->BEOUT; beout != 0; beout = beout->NEXT )
		if ( beout->ABL != 0 )
			beout->ABL = substablexpr( beout->ABL, OldName, rep_expr );

	for ( bebus = BehFigure->BEBUS; bebus != 0; bebus = bebus->NEXT ) {
		for ( biabl = bebus->BIABL; biabl != 0; biabl = biabl->NEXT ) {
			if ( biabl->VALABL != 0 )
				biabl->VALABL = substablexpr( biabl->VALABL, OldName, rep_expr );
			if ( biabl->CNDABL != 0 )
				biabl->CNDABL = substablexpr( biabl->CNDABL, OldName, rep_expr );
		}
	}

	for ( bereg = BehFigure->BEREG; bereg != 0; bereg = bereg->NEXT ) {
		for ( biabl = bereg->BIABL; biabl != 0; biabl = biabl->NEXT ) {
			if ( biabl->VALABL != 0 )
				biabl->VALABL = substablexpr( biabl->VALABL, OldName, rep_expr );
			if ( biabl->CNDABL != 0 )
				biabl->CNDABL = substablexpr( biabl->CNDABL, OldName, rep_expr );
		}
	}

	for ( bebux = BehFigure->BEBUX; bebux != 0; bebux = bebux->NEXT ) {
		for ( biabl = bebux->BIABL; biabl != 0; biabl = biabl->NEXT ) {
			if ( biabl->VALABL != 0 )
				biabl->VALABL = substablexpr( biabl->VALABL, OldName, rep_expr );
			if ( biabl->CNDABL != 0 )
				biabl->CNDABL = substablexpr( biabl->CNDABL, OldName, rep_expr );
		}
	}

}

