/*
 * $Author: ac $
 * $Id: fpm_load.c,v 1.3 2000/12/13 15:45:48 ac Exp $
 * $Date: 2000/12/13 15:45:48 $
 */
/*
 * $Log: fpm_load.c,v $
 * Revision 1.3  2000/12/13 15:45:48  ac
 * modification de la reconnaissance des registres.
 *
 * Revision 1.2  1999/10/21 12:52:05  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 * Revision 1.2  1998/02/11 17:34:36  ac
 * fpmap version 0.62
 *
 * Revision 1.1  1997/11/14 11:49:46  ac
 * Initial revision
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  BDD_H
#include  ABE_H
#include  ABV_H
#include  BUT_H
#include "fpm_network.h"
#include "fpm_user.h"
#include "fpm_bdd.h"
#include "fpm_load.h"

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/* #define DEBUG */

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

static char *is_ff_re __P((biabl_list * BiAbl, chain_list * Clock));
static char *is_ff_fe __P((biabl_list * BiAbl, chain_list * Clock));
static char *is_latch_ah __P((biabl_list * BiAbl, chain_list * Clock));
static char *is_latch_al __P((biabl_list * BiAbl, chain_list * Clock));
static char *is_stable __P((chain_list * Clock, ablexpr * Expr));
static char *is_clock __P((chain_list * Clock, char *Name));
static void get_reg_atoms __P((char *Name, biabl_list * BiAbl, ablexpr ** Val, ablexpr ** CndExpr));
static void fpmcompil __P((void));
static void fpmfreeabl __P((void));

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                               is_stable                              */
/*----------------------------------------------------------------------*/

static char *
is_stable(chain_list * Clock, ablexpr * Expr)
{
	if (Expr == 0)
		return 0;

	if (ABL_ATOM(Expr) || ABL_OPER(Expr) != ABL_NOT)
		return 0;

	Expr = ABL_CADR(Expr);
	if (ABL_ATOM(Expr) || ABL_OPER(Expr) != ABL_STABLE)
		return 0;

	Expr = ABL_CADR(Expr);
	if (ABL_ATOM(Expr))
		return is_clock(Clock, ABL_ATOM_VALUE(Expr));

	return 0;
}

/*----------------------------------------------------------------------*/
/*                               is_ff_re                               */
/*----------------------------------------------------------------------*/

static char *
is_ff_re(biabl_list * BiAbl, chain_list * Clock)
{
	chain_list *Expr;
	char *Name;

	Expr = simpablexpr(BiAbl->CNDABL);

	if (ABL_ATOM(Expr) || (ABL_OPER(Expr) != ABL_AND))
		return 0;

	if (ABL_ATOM(ABL_CADR(Expr))) {

		Name = ABL_ATOM_VALUE(ABL_CADR(Expr));

		if ((is_clock(Clock, Name)) &&
		    (is_stable(Clock, ABL_CAR(ABL_CDDR(Expr))) == Name))
			return Name;
		else
			return 0;
	}
	if (ABL_ATOM(ABL_CAR(ABL_CDDR(Expr)))) {

		Name = ABL_ATOM_VALUE(ABL_CAR(ABL_CDDR(Expr)));

		if ((is_clock(Clock, Name)) &&
		    (is_stable(Clock, ABL_CADR(Expr)) == Name))
			return Name;
		else
			return 0;
	}
	return 0;
}

/*----------------------------------------------------------------------*/
/*                               is_ff_fe                               */
/*----------------------------------------------------------------------*/

static char *
is_ff_fe(biabl_list * BiAbl, chain_list * Clock)
{
	chain_list *Expr;
	char *Name;

	Expr = simpablexpr(BiAbl->CNDABL);

	if (ABL_ATOM(Expr) || (ABL_OPER(Expr) != ABL_AND))
		return 0;

	if ((ABL_ATOM(ABL_CADR(Expr))) ||
	    (ABL_ATOM(ABL_CAR(ABL_CDDR(Expr)))))
		return 0;

	if ((ABL_OPER(ABL_CADR(Expr)) != ABL_NOT) ||
	    (ABL_OPER(ABL_CAR(ABL_CDDR(Expr))) != ABL_NOT))
		return 0;

	if (ABL_ATOM(ABL_CADR(ABL_CADR(Expr)))) {

		Name = ABL_ATOM_VALUE(ABL_CADR(ABL_CADR(Expr)));

		if ((is_clock(Clock, Name)) &&
		    (is_stable(Clock, ABL_CAR(ABL_CDDR(Expr))) == Name))
			return Name;
		else
			return 0;
	}
	if (ABL_ATOM(ABL_CADR(ABL_CAR(ABL_CDDR(Expr))))) {

		Name = ABL_ATOM_VALUE(ABL_CADR(ABL_CAR(ABL_CDDR(Expr))));

		if ((is_clock(Clock, Name)) &&
		    (is_stable(Clock, ABL_CADR(Expr)) == Name))
			return Name;
		else
			return 0;
	}
	return 0;
}

/*----------------------------------------------------------------------*/
/*                              is_latch_ah                             */
/*----------------------------------------------------------------------*/

static char *
is_latch_ah(biabl_list * BiAbl, chain_list * Clock)
{
	chain_list *Expr;

	Expr = simpablexpr(BiAbl->CNDABL);
	if (ABL_ATOM(Expr))
		return is_clock(Clock, ABL_ATOM_VALUE(Expr));

	return 0;
}

/*----------------------------------------------------------------------*/
/*                              is_latch_al                             */
/*----------------------------------------------------------------------*/

static char *
is_latch_al(biabl_list * BiAbl, chain_list * Clock)
{
	chain_list *Expr;

	Expr = simpablexpr(BiAbl->CNDABL);
	if (ABL_ATOM(Expr) || ABL_OPER(Expr) != ABL_NOT)
		return 0;

	Expr = ABL_CADR(Expr);
	if (ABL_ATOM(Expr))
		return is_clock(Clock, ABL_ATOM_VALUE(Expr));

	return 0;
}

/*----------------------------------------------------------------------*/
/*                               is_clock                               */
/*----------------------------------------------------------------------*/

static char *
is_clock(chain_list * Clock, char *Name)
{
	while (Clock != NULL) {
		if (Name == (char *) Clock->DATA)
			return Name;

		Clock = Clock->NEXT;
	}
	return 0;
}

/*----------------------------------------------------------------------*/
/*                            get_reg_atoms                            */
/*----------------------------------------------------------------------*/

static void
get_reg_atoms(char *Name, biabl_list * BiAbl, chain_list ** ValExpr, chain_list ** CndExpr)
{
	chain_list *Expr;
	chain_list *Expr1;
	chain_list *Expr2;

	Expr = BiAbl->VALABL;

	if (ABL_ATOM(Expr) || ABL_OPER(Expr) != ABL_OR) {
		*ValExpr = Expr;
		*CndExpr = 0;
		return;
	}
	Expr1 = ABL_CADR(Expr);
	Expr2 = ABL_CAR(ABL_CDDR(Expr));
	if (ABL_ATOM(Expr1) || (ABL_OPER(Expr1) != ABL_AND) ||
	    ABL_ATOM(Expr2) || (ABL_OPER(Expr2) != ABL_AND)) {
		*ValExpr = Expr;
		*CndExpr = 0;
		return;
	}
	if ((ABL_ATOM(ABL_CADR(Expr1))) &&
	    (ABL_ATOM_VALUE(ABL_CADR(Expr1)) == Name)) {

		*CndExpr = ABL_CAR(ABL_CDDR(Expr1));
		if (isablnotexpr(*CndExpr, ABL_CADR(Expr2))) {
			*CndExpr = ABL_CADR(Expr2);
			*ValExpr = ABL_CAR(ABL_CDDR(Expr2));
			return;
		} else if (isablnotexpr(*CndExpr, ABL_CAR(ABL_CDDR(Expr2)))) {
			*CndExpr = ABL_CAR(ABL_CDDR(Expr2));
			*ValExpr = ABL_CADR(Expr2);
			return;
		}
	} else if ((ABL_ATOM(ABL_CAR(ABL_CDDR(Expr1)))) &&
		   (ABL_ATOM_VALUE(ABL_CAR(ABL_CDDR(Expr1))) == Name)) {
		*CndExpr = ABL_CADR(Expr1);
		if (isablnotexpr(*CndExpr, ABL_CADR(Expr2))) {
			*CndExpr = ABL_CADR(Expr2);
			*ValExpr = ABL_CAR(ABL_CDDR(Expr2));
			return;
		} else if (isablnotexpr(*CndExpr, ABL_CAR(ABL_CDDR(Expr2)))) {
			*CndExpr = ABL_CAR(ABL_CDDR(Expr2));
			*ValExpr = ABL_CADR(Expr2);
			return;
		}
	} else if ((ABL_ATOM(ABL_CADR(Expr2))) &&
		   (ABL_ATOM_VALUE(ABL_CADR(Expr2)) == Name)) {
		*CndExpr = ABL_CAR(ABL_CDDR(Expr2));
		if (isablnotexpr(*CndExpr, ABL_CADR(Expr1))) {
			*CndExpr = ABL_CADR(Expr1);
			*ValExpr = ABL_CAR(ABL_CDDR(Expr1));
			return;
		} else if (isablnotexpr(*CndExpr, ABL_CAR(ABL_CDDR(Expr1)))) {
			*CndExpr = ABL_CAR(ABL_CDDR(Expr1));
			*ValExpr = ABL_CADR(Expr1);
			return;
		}
	} else if ((ABL_ATOM(ABL_CAR(ABL_CDDR(Expr2)))) &&
		   (ABL_ATOM_VALUE(ABL_CAR(ABL_CDDR(Expr2))) == Name)) {
		*CndExpr = ABL_CADR(Expr2);
		if (isablnotexpr(*CndExpr, ABL_CADR(Expr1))) {
			*CndExpr = ABL_CADR(Expr1);
			*ValExpr = ABL_CAR(ABL_CDDR(Expr1));
			return;
		} else if (isablnotexpr(*CndExpr, ABL_CAR(ABL_CDDR(Expr1)))) {
			*CndExpr = ABL_CAR(ABL_CDDR(Expr1));
			*ValExpr = ABL_CADR(Expr1);
			return;
		}
	}
	*ValExpr = Expr;
	*CndExpr = 0;
}

/*----------------------------------------------------------------------*/
/*                               fpmcompil                              */
/*----------------------------------------------------------------------*/

static void
fpmcompil()
{
	bereg_list *BehReg;
	biabl_list *BiAbl;
	char *ClkName;
	ablexpr *ValExpr;
	ablexpr *CndExpr;
	chain_list *Clock;

	beh_frebeaux(FpmUser->BEFIG->BEDLY);
	FpmUser->BEFIG->BEDLY = NULL;
	beh_frebemsg(FpmUser->BEFIG->BEMSG);
	FpmUser->BEFIG->BEMSG = NULL;
	beh_frebegen(FpmUser->BEFIG->BEGEN);
	FpmUser->BEFIG->BEGEN = NULL;
	beh_frebepgm(FpmUser->BEFIG->BEPGM);
	FpmUser->BEFIG->BEPGM = NULL;

	Clock = FpmUser->CLOCKS;

	for (BehReg = FpmUser->BEFIG->BEREG; BehReg != 0; BehReg = BehReg->NEXT) {

		for (BiAbl = BehReg->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {

			if ((ClkName = is_ff_re(BiAbl, Clock)) != 0) {
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_TYPE,
						       (void *) FP_FF_RE);
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_NAME, ClkName);
			} else if ((ClkName = is_ff_fe(BiAbl, Clock)) != 0) {
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_TYPE,
						       (void *) FP_FF_FE);
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_NAME, ClkName);
			} else if ((ClkName = is_latch_ah(BiAbl, Clock)) != 0) {
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_TYPE,
						   (void *) FP_LATCH_AH);
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_NAME, ClkName);
			} else if ((ClkName = is_latch_al(BiAbl, Clock)) != 0) {
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_TYPE,
						   (void *) FP_LATCH_AL);
				BiAbl->USER = addptype(BiAbl->USER, FP_CLOCK_NAME, ClkName);
			} else
				bflerror(1, "error: invalid block condition on register `%s'",
					 BehReg->NAME);

			get_reg_atoms(BehReg->NAME, BiAbl, &ValExpr, &CndExpr);
			BiAbl->VALABL = ValExpr;
			BiAbl->CNDABL = CndExpr;
		}
	}
}

static char *
fpmname(char *Name)
{
	char Buf[BUFSIZ];

	strcpy(Buf, Name);
	for (Name = Buf; *Name != 0; Name++)
		if (*Name == ' ')
			*Name = '_';
	return namealloc(Buf);
}

static void
fpmsubstabl(befig_list * BehFigure, char *Name, char *Replace)
{
	berin_list *BehRin;
	beaux_list *BehAux;
	beout_list *BehOut;
	bebus_list *BehBus;
	bereg_list *BehReg;
	bebux_list *BehBux;
	biabl_list *BiAbl;
	ablexpr *RepExpr;

	RepExpr = createablatom(Replace);

	for (BehRin = BehFigure->BERIN; BehRin != 0; BehRin = BehRin->NEXT)
		if (BehRin->NAME == Name)
			BehRin->NAME = Replace;

	for (BehAux = BehFigure->BEAUX; BehAux != 0; BehAux = BehAux->NEXT)
		if (BehAux->ABL != 0)
			BehAux->ABL = substablexpr(BehAux->ABL, Name, RepExpr);

	for (BehOut = BehFigure->BEOUT; BehOut != 0; BehOut = BehOut->NEXT)
		if (BehOut->ABL != 0)
			BehOut->ABL = substablexpr(BehOut->ABL, Name, RepExpr);

	for (BehBus = BehFigure->BEBUS; BehBus != 0; BehBus = BehBus->NEXT) {
		for (BiAbl = BehBus->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->VALABL != 0)
				BiAbl->VALABL = substablexpr(BiAbl->VALABL, Name, RepExpr);
			if (BiAbl->CNDABL != 0)
				BiAbl->CNDABL = substablexpr(BiAbl->CNDABL, Name, RepExpr);
		}
	}

	for (BehReg = BehFigure->BEREG; BehReg != 0; BehReg = BehReg->NEXT) {
		for (BiAbl = BehReg->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->VALABL != 0)
				BiAbl->VALABL = substablexpr(BiAbl->VALABL, Name, RepExpr);
			if (BiAbl->CNDABL != 0)
				BiAbl->CNDABL = substablexpr(BiAbl->CNDABL, Name, RepExpr);
		}
	}

	for (BehBux = BehFigure->BEBUX; BehBux != 0; BehBux = BehBux->NEXT) {
		for (BiAbl = BehBux->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->VALABL != 0)
				BiAbl->VALABL = substablexpr(BiAbl->VALABL, Name, RepExpr);
			if (BiAbl->CNDABL != 0)
				BiAbl->CNDABL = substablexpr(BiAbl->CNDABL, Name, RepExpr);
		}
	}

}

void
fpmunvector(void)
{
	befig_list *BehFigure;
	beaux_list *BehAux;
	char *NewName;

	BehFigure = FpmUser->BEFIG;

	for (BehAux = BehFigure->BEAUX; BehAux != 0; BehAux = BehAux->NEXT) {
		if (strchr(BehAux->NAME, ' ') != 0) {
			NewName = fpmname(BehAux->NAME);
			fpmsubstabl(BehFigure, BehAux->NAME, NewName);
			BehAux->NAME = NewName;
		}
	}
}

/*----------------------------------------------------------------------*/
/*                              fpmfreeabl                              */
/*----------------------------------------------------------------------*/

static void
fpmfreeabl()
{
	befig_list *BehFig;
	beaux_list *BehAux;
	beout_list *BehOut;
	bebus_list *BehBus;
	bebux_list *BehBux;
	bereg_list *BehReg;
	biabl_list *BiAbl;

	BehFig = FpmUser->BEFIG;

	for (BehAux = BehFig->BEAUX; BehAux != 0; BehAux = BehAux->NEXT) {
		freeablexpr(BehAux->ABL);
		BehAux->ABL = NULL;
	}

	for (BehOut = BehFig->BEOUT; BehOut != 0; BehOut = BehOut->NEXT) {
		freeablexpr(BehOut->ABL);
		BehOut->ABL = NULL;
	}

	for (BehBus = BehFig->BEBUS; BehBus != 0; BehBus = BehBus->NEXT)
		for (BiAbl = BehBus->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->CNDABL != NULL) {
				freeablexpr(BiAbl->CNDABL);
				BiAbl->CNDABL = NULL;
			}
			if (BiAbl->VALABL != NULL) {
				freeablexpr(BiAbl->VALABL);
				BiAbl->VALABL = NULL;
			}
		}

	for (BehBux = BehFig->BEBUX; BehBux != 0; BehBux = BehBux->NEXT)
		for (BiAbl = BehBux->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->CNDABL != NULL) {
				freeablexpr(BiAbl->CNDABL);
				BiAbl->CNDABL = NULL;
			}
			if (BiAbl->VALABL != NULL) {
				freeablexpr(BiAbl->VALABL);
				BiAbl->VALABL = NULL;
			}
		}

	for (BehReg = BehFig->BEREG; BehReg != 0; BehReg = BehReg->NEXT)
		for (BiAbl = BehReg->BIABL; BiAbl != 0; BiAbl = BiAbl->NEXT) {
			if (BiAbl->CNDABL != NULL) {
				freeablexpr(BiAbl->CNDABL);
				BiAbl->CNDABL = NULL;
			}
			if (BiAbl->VALABL != NULL) {
				freeablexpr(BiAbl->VALABL);
				BiAbl->VALABL = NULL;
			}
		}
}

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                              beh_compil                              */
/*----------------------------------------------------------------------*/

void
fpm_load()
{
	int Flag;

	printf("\n * Loading vhdl file `%s.vbe' ...\n", FpmUser->FILE_VHDL);
	FpmUser->BEFIG = vhdlloadbefig(0, FpmUser->FILE_VHDL, 2);

	printf("   - Compiling ...\n");
	fpmcompil();
	/*
	 * but_compil( FpmUser->BEFIG, FpmUser->CLOCKS );
	 */

	printf("   - Checking ...\n");
	(*FpmUser->ARCHI_CHECK) ();

	but_unvector(FpmUser->BEFIG, BUT_BEAUX);	/* fpmunvector(); */

	but_sweep(FpmUser->BEFIG, BUT_SWEEP_ABL);

#ifdef DEBUG
	fpmviewbefig(FpmUser->BEFIG);
#endif
	/* fpmmakebdd(); */
	Flag = FPN_VERBOSE + (FPN_ABL_ORDER * (FpmUser->ABL_ORDER != 0)) + (FPN_FLATTEN_BEH * (FpmUser->FLATTEN != 0));

	fpm_make_bdd(FpmUser->BEFIG, Flag, FpmUser->SAVED_AUX);

	fpmfreeabl();

	FpmUser->BEFIG->NAME = FpmUser->FILE_EXPR;
}
