
/*
 * $Author: ac $
 * $Id: virtex.h,v 1.1 1999/10/21 12:52:09 ac Exp $
 * $Date: 1999/10/21 12:52:09 $
 */
/*
 * $Log: virtex.h,v $
 * Revision 1.1  1999/10/21 12:52:09  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 */

#ifndef __virtex_h
#define __virtex_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

#define VIRTEX_MAPPED		( 1 << 1 )	/*  2 */
#define VIRTEX_INVERTED		( 1 << 2 )	/*  4 */

#define VIRTEX_LUT_SIZE		4

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
#ifdef __STDC__
#define __P(args)	args
#else
#define __P(args)	()
#endif
#endif

#define VIRTEX_IS_MAPPED( Flag )		( Flag & VIRTEX_MAPPED )
#define VIRTEX_IS_INVERTED( Flag )	( Flag & VIRTEX_INVERTED )

#define VIRTEX_SET_MAPPED( Flag)		( Flag |= VIRTEX_MAPPED )
#define VIRTEX_SET_INVERTED( Flag)	( Flag |= VIRTEX_INVERTED )

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

extern void	 virtex_init   __P((void));
extern void	 virtex_done   __P((void));
extern void	 virtex_check  __P((void));
extern void	 virtex_cost   __P((fpm_expr_t *, long *, long *));
extern void	 virtex_clear  __P((fpm_atom_t *));
extern ablexpr	*virtex_mapp   __P((bddnode *Node, int CreateAux));
extern void	 virtex_report __P((void));
extern void	 virtex_save   __P((void));

#endif	/* __virtex_h */
