/*
 * $Author: ac $
 * $Id: x4000.c,v 1.3 2000/12/13 15:45:48 ac Exp $
 * $Date: 2000/12/13 15:45:48 $
 */
/*
 * $Log: x4000.c,v $
 * Revision 1.3  2000/12/13 15:45:48  ac
 * modification de la reconnaissance des registres.
 *
 * Revision 1.2  1999/10/21 12:52:09  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:41  alliance
 * fpmap import
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <assert.h>
#include  MUT_H
#include  BFL_H
#include  AUT_H
#include  ABL_H
#include  BDD_H
#include  ABE_H
#include  XNF_H
#include "fpm_network.h"
#include "fpm_user.h"
#include "fpm_load.h"
#include "fpm_mapp.h"
#include "fpm_util.h"
#include "x4000.h"

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

static int		 X4_CLB_F;
static int		 X4_CLB_H;
static authtable	*x4_depth_hash;

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

static chain_list *
x4_cost_force(bddnode * Node, long Length, long *Depth, long *Count)
{
	bddnode *NodeLow;
	bddnode *NodeHigh;
	bddnode *NodeInv;

	NodeLow = Node->LOW;
	NodeHigh = Node->HIGH;
	*Depth += 1;

	if ((Length == 2) &&
	    (X4_IS_MAPPED(NodeLow->MARK)) &&
	    (!X4_IS_CLB(NodeLow->MARK)) &&
	    (X4_IS_MAPPED(NodeHigh->MARK)) &&
	    (!X4_IS_CLB(NodeHigh->MARK))) {

		X4_SET_CLB_F(NodeLow->MARK);
		NodeLow = applybddnodenot(0, NodeLow);
		decbddrefext(NodeLow);
		X4_SET_CLB_F(NodeLow->MARK);

		X4_SET_CLB_F(NodeHigh->MARK);
		NodeHigh = applybddnodenot(0, NodeHigh);
		decbddrefext(NodeHigh);
		X4_SET_CLB_F(NodeHigh->MARK);

		X4_SET_MAPPED(Node->MARK);
		X4_SET_CLB_H(Node->MARK);
		addauthelem(x4_depth_hash, (char *)Node, *Depth);

		NodeInv = applybddnodenot(0, Node);
		decbddrefext(NodeInv);
		X4_SET_MAPPED(NodeInv->MARK);
		X4_SET_INVERTED(NodeInv->MARK);
		X4_SET_CLB_H(NodeInv->MARK);

		return (addchain(0, Node));
	}
	*Count += 1;

	X4_SET_MAPPED(Node->MARK);
	addauthelem(x4_depth_hash, (char *)Node, *Depth);

	NodeInv = applybddnodenot(0, Node);
	decbddrefext(NodeInv);
	X4_SET_MAPPED(NodeInv->MARK);
	X4_SET_INVERTED(NodeInv->MARK);

	return (addchain(0, Node));
}

static chain_list *
x4_cost_rec(bddnode * Node, long *Count, long *Depth)
{
	authelem     *HashElem;
	bddnode      *NodeInv;
	bddnode      *NodeAnd;
	bddnode      *NodeLow;
	bddnode      *NodeHigh;
	chain_list   *ListLow;
	chain_list   *ListHigh;
	long          DepthLow;
	long          DepthHigh;
	long          LengthHigh;
	long          LengthLow;

	if (Node->INDEX < 2) {
		*Depth = 0;
		return (chain_list *) 0;
	}
	if (Node->LOW->INDEX < 2 && Node->HIGH->INDEX < 2) {
		*Depth = 0;
		return (addchain(0, ((void *) (int) Node->INDEX)));
	}
	if (X4_IS_MAPPED(Node->MARK)) {
		if (X4_IS_INVERTED(Node->MARK)) {
			Node = applybddnodenot(0, Node);
			decbddrefext(Node);
		}
		assert(HashElem = searchauthelem(x4_depth_hash, (char *)Node));
		*Depth = HashElem->VALUE;
		return (addchain(0, Node));
	}

	NodeAnd = applybddnode(0, ABL_AND, Node->HIGH, Node->LOW);
	decbddrefext(NodeAnd);

	if (NodeAnd == Node->LOW) {
		NodeLow = Node->LOW;
		NodeHigh = simpbddnodedcon(0, Node->HIGH, Node->LOW);
		decbddrefext(NodeHigh);
	} else if (NodeAnd == Node->HIGH) {
		NodeLow = simpbddnodedcon(0, Node->LOW, Node->HIGH);
		decbddrefext(NodeLow);
		NodeHigh = Node->HIGH;
	} else {
		NodeLow = Node->LOW;
		NodeHigh = Node->HIGH;
	}

	ListLow = x4_cost_rec(NodeLow, Count, &DepthLow);
	ListHigh = x4_cost_rec(NodeHigh, Count, &DepthHigh);

	while (1) {
		chain_list *Result;

		switch (fpm_support_size(ListLow, ListHigh)) {
		case 2:
			if ((X4_IS_MAPPED(NodeLow->MARK)) &&
			    (!X4_IS_CLB(NodeLow->MARK)) &&
			    (X4_IS_MAPPED(NodeHigh->MARK)) &&
			    (!X4_IS_CLB(NodeHigh->MARK))) {

				freechain(ListLow);
				freechain(ListHigh);

				X4_SET_CLB_F(NodeLow->MARK);
				NodeLow = applybddnodenot(0, NodeLow);
				decbddrefext(NodeLow);
				X4_SET_CLB_F(NodeLow->MARK);

				X4_SET_CLB_F(NodeHigh->MARK);
				NodeHigh = applybddnodenot(0, NodeHigh);
				decbddrefext(NodeHigh);
				X4_SET_CLB_F(NodeHigh->MARK);

				*Depth = 1 + (DepthLow > DepthHigh) ? DepthLow : DepthHigh;

				Node->MARK |= (X4_MASK_MAPPED | X4_MASK_CLB_H);
				addauthelem(x4_depth_hash, (char *)Node, *Depth);

				NodeInv = applybddnodenot(0, Node);
				decbddrefext(NodeInv);
				NodeInv->MARK |= (X4_MASK_MAPPED | X4_MASK_INVERTED | X4_MASK_CLB_H);

				return (addchain(0, Node));
			}
			/* Pas de break, on continue dans le case 1... */

		case 1:
			Result = fpm_merge_chain(ListLow, ListHigh);
			*Depth = (DepthLow > DepthHigh) ? DepthLow : DepthHigh;
			return (addchain(Result, ((void *) (int) Node->INDEX)));

		case 3:	/* on cree un CLB F/G */
			freechain(ListLow);
			freechain(ListHigh);

			*Depth = 1 + (DepthLow > DepthHigh) ? DepthLow : DepthHigh;
			*Count += 1;

			Node->MARK |= X4_MASK_MAPPED;
			addauthelem(x4_depth_hash, (char *)Node, *Depth);

			NodeInv = applybddnodenot(0, Node);
			decbddrefext(NodeInv);
			NodeInv->MARK |= (X4_MASK_MAPPED | X4_MASK_INVERTED);

			return (addchain(0, Node));

		default:
			LengthLow = fpm_length_chain(ListLow);
			LengthHigh = fpm_length_chain(ListHigh);

			if (LengthLow > LengthHigh) {
				freechain(ListLow);
				ListLow = x4_cost_force(NodeLow, LengthLow, &DepthLow, Count);
			} else {
				freechain(ListHigh);
				ListHigh = x4_cost_force(NodeHigh, LengthHigh, &DepthHigh, Count);
			}
		}		/* switch */
	}			/* while(1) */
}

static chain_list *
x4_mapp_force(bddnode * Node, ablexpr ** Expr)
{
	bddnode *NodeLow;
	bddnode *NodeHigh;
	bddnode *NodeInv;

	NodeLow = Node->LOW;
	NodeHigh = Node->HIGH;

	if ((X4_IS_MAPPED(NodeLow->MARK)) &&
	    (!X4_IS_CLB(NodeLow->MARK)) &&
	    (X4_IS_MAPPED(NodeHigh->MARK)) &&
	    (!X4_IS_CLB(NodeHigh->MARK))) {

		X4_SET_CLB_F(NodeLow->MARK);
		NodeLow = decbddrefext(applybddnodenot(0, NodeLow));
		X4_SET_CLB_F(NodeLow->MARK);

		X4_SET_CLB_F(NodeHigh->MARK);
		NodeHigh = decbddrefext(applybddnodenot(0, NodeHigh));
		X4_SET_CLB_F(NodeHigh->MARK);

		fpm_mapp_node(Node, Expr);
		X4_CLB_H++;
		X4_SET_MAPPED(Node->MARK);
		X4_SET_CLB_H(Node->MARK);
		NodeInv = decbddrefext(applybddnodenot(0, Node));
		X4_SET_MAPPED(NodeInv->MARK);
		X4_SET_CLB_H(NodeInv->MARK);
		X4_SET_INVERTED(NodeInv->MARK);

		return (addchain(0, ((void *) (int) Node->INDEX)));
	}
	fpm_mapp_node(Node, Expr);
	X4_CLB_F++;
	X4_SET_MAPPED(Node->MARK);
	NodeInv = decbddrefext(applybddnodenot(0, Node));
	X4_SET_MAPPED(NodeInv->MARK);
	X4_SET_INVERTED(NodeInv->MARK);

	return (addchain(0, ((void *) (int) Node->INDEX)));
}

/*----------------------------------------------------------------------*/
/*       ablexpr *x4_make_expr( Atom, ExprLow, ExprHigh, Inclus )       */
/*----------------------------------------------------------------------*/

static ablexpr *
x4_make_expr(Atom, ExprLow, ExprHigh, Inclus)
	ablexpr *Atom;
	ablexpr *ExprLow;
	ablexpr *ExprHigh;
	int Inclus;
{
	ablexpr *Expr = (ablexpr *) 0;

	switch (Inclus) {
	case 0:
		Expr = createablbinexpr(ABL_OR,
					createablbinexpr(ABL_AND,
							 ExprHigh,
						       dupablexpr(Atom)),
					createablbinexpr(ABL_AND,
							 ExprLow,
						createablnotexpr(Atom)));
		break;

	case 1:
		Expr = createablbinexpr(ABL_OR,
			       createablbinexpr(ABL_AND, ExprHigh, Atom),
					ExprLow);
		break;

	case 2:
		Expr = createablbinexpr(ABL_OR,
					ExprHigh,
					createablbinexpr(ABL_AND,
							 ExprLow,
						createablnotexpr(Atom)));
		break;

	default:
		bflerror(1, "x4_make_expr: invalid inclusion flag (%d)", Inclus);

	}
	return Expr;
}

static ablexpr *
x4_get_abl( bddindex Index )
{
	bddnamein *NameIn    = FpmUser->NETWORK->NAME_IN;
	bddindex  *NameIndex = FpmUser->NETWORK->INDEX_IN;

	return convertbddindexabl(0, NameIn, NameIndex, Index);
}

/*----------------------------------------------------------------------*/
/*           chain_list *x4_mapp_rec( Node, Expr, CreateAux )           */
/*----------------------------------------------------------------------*/

static chain_list *
x4_mapp_rec(bddnode * Node, ablexpr ** Expr, int CreateAux)
{
	bddnode *NodeInv;
	bddnode *NodeAnd;
	bddnode *NodeLow;
	bddnode *NodeHigh;
	int Inclus;
	ablexpr *ExprLow;
	ablexpr *ExprHigh;
	chain_list *ListLow;
	chain_list *ListHigh;
	long LengthHigh;
	long LengthLow;

	/*
	 * Noeud terminal
	 */
	if (Node->INDEX < 2) {
		if (Node->INDEX == BDD_INDEX_ZERO) {
			*Expr = createablatomzero();
			return (chain_list *) 0;
		} else {
			*Expr = createablatomone();
			return (chain_list *) 0;
		}
	}
	/*
	 * Variable atomique
	 */
	if (Node->LOW->INDEX < 2 && Node->HIGH->INDEX < 2) {
		*Expr = x4_get_abl(Node->INDEX);
		if (Node->LOW->INDEX == BDD_INDEX_ONE)	/* Noeud inverse */
			*Expr = createablnotexpr(*Expr);
		return (addchain(0, ((void *) (int) Node->INDEX)));
	}
	/* simplifications eventuelles avant l'appel recursif sur les fils.
	 * Inclus est mis a jour :
	 *     Inclus = 0 pas d'inclusion (par defaut)
	 *     Inclus = 1 low est inclus dans high
	 *     Inclus = 2 high est inclus dans low
	 */

	NodeAnd = applybddnode(0, ABL_AND, Node->HIGH, Node->LOW);

	if (NodeAnd == Node->LOW) {
		Inclus = 1;
		NodeLow = Node->LOW;
		NodeHigh = simpbddnodedcon(0, Node->HIGH, Node->LOW);
	} else if (NodeAnd == Node->HIGH) {
		Inclus = 2;
		NodeLow = simpbddnodedcon(0, Node->LOW, Node->HIGH);
		NodeHigh = Node->HIGH;
	} else {
		Inclus = 0;
		NodeLow = Node->LOW;
		NodeHigh = Node->HIGH;
	}
	decbddrefext(NodeAnd);

	ListLow = x4_mapp_rec(NodeLow, &ExprLow, 1);
	ListHigh = x4_mapp_rec(NodeHigh, &ExprHigh, 1);

	while (1) {
		chain_list *Result;

		switch (fpm_support_size(ListLow, ListHigh)) {
		case 2:
			if ((X4_IS_MAPPED(NodeLow->MARK)) &&
			    (!X4_IS_CLB(NodeLow->MARK)) &&
			    (X4_IS_MAPPED(NodeHigh->MARK)) &&
			    (!X4_IS_CLB(NodeHigh->MARK))) {

				freechain(ListLow);
				freechain(ListHigh);

				X4_SET_CLB_F(NodeLow->MARK);
				NodeLow = decbddrefext(applybddnodenot(0, NodeLow));
				X4_SET_CLB_F(NodeLow->MARK);

				X4_SET_CLB_F(NodeHigh->MARK);
				NodeHigh = decbddrefext(applybddnodenot(0, NodeHigh));
				X4_SET_CLB_F(NodeHigh->MARK);

				*Expr = x4_make_expr(x4_get_abl(Node->INDEX),
					      ExprLow, ExprHigh, Inclus);
				if (CreateAux == 1) {
					fpm_mapp_node(Node, Expr);
					X4_CLB_H++;
#ifdef DEBUG
					printf("       LUT H\n");
#endif
					X4_SET_MAPPED(Node->MARK);
					X4_SET_CLB_H(Node->MARK);
					NodeInv = decbddrefext(applybddnodenot(0, Node));
					X4_SET_MAPPED(NodeInv->MARK);
					X4_SET_CLB_H(NodeInv->MARK);
					X4_SET_INVERTED(NodeInv->MARK);
				}
				return (addchain(0, ((void *) (int) Node->INDEX)));
			}
			/* Pas de break ni return ... Continue dans case 1 */

		case 1:
			Result = fpm_merge_chain(ListLow, ListHigh);
			*Expr = x4_make_expr(x4_get_abl(Node->INDEX),
					     ExprLow, ExprHigh, Inclus);
			return (addchain(Result, ((void *) (int) Node->INDEX)));

		case 3:	/* on cree un CLB F/G */
			freechain(ListLow);
			freechain(ListHigh);

			*Expr = x4_make_expr(x4_get_abl(Node->INDEX),
					     ExprLow, ExprHigh, Inclus);
			if (CreateAux == 1) {
				fpm_mapp_node(Node, Expr);
				X4_CLB_F++;
				X4_SET_MAPPED(Node->MARK);
				NodeInv = decbddrefext(applybddnodenot(0, Node));
				X4_SET_MAPPED(NodeInv->MARK);
				X4_SET_INVERTED(NodeInv->MARK);
			}
			return (addchain(0, ((void *) (int) Node->INDEX)));

		default:
			LengthLow = fpm_length_chain(ListLow);
			LengthHigh = fpm_length_chain(ListHigh);

			if (LengthLow > LengthHigh) {
				freechain(ListLow);
				ListLow = x4_mapp_force(NodeLow, &ExprLow);
			} else {
				freechain(ListHigh);
				ListHigh = x4_mapp_force(NodeHigh, &ExprHigh);
			}
		}		/* switch */
	}			/* while(1) */
	/* not reached */
	return 0;
}

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                            void x4_check()                           */
/*----------------------------------------------------------------------*/

void
x4_init()
{
	x4_depth_hash = createauthtable(4096);
}

void
x4_done()
{
	/* destroyauthtable(x4_depth_hash); */
}

void
x4_check()
{
	befig_list *BehFigure;
	bereg_list *BehReg;
	bebus_list *BehBus;
	bebux_list *BehBux;
	ptype_list *ClockType;
	int IobMode;
	int Error;

	BehFigure = FpmUser->BEFIG;
	IobMode = FpmUser->IOB_MODE;
	Error = 0;

	if (BehFigure == 0)
		bflerror(1, "x4_check: error: figure is empty");

	for (BehReg = BehFigure->BEREG; BehReg != 0; BehReg = BehReg->NEXT) {
		if (BehReg->BIABL->NEXT != 0) {
			Error = 1;
			bflwarning("x4_check: error: multiple drivers on register `%s'",
				   BehReg->NAME);
		}
		ClockType = getptype(BehReg->BIABL->USER, FP_CLOCK_TYPE);
		if ((ClockType == 0) ||
		    (ClockType->DATA == (void *) FP_LATCH_AH) ||
		    (ClockType->DATA == (void *) FP_LATCH_AL)) {
			Error = 1;
			bflwarning("x4_check: error: register `%s' is a latch", BehReg->NAME);
		}
	}

	for (BehBus = BehFigure->BEBUS; BehBus != 0; BehBus = BehBus->NEXT) {
		if (IobMode == 1 && BehBus->BIABL->NEXT != 0) {
			Error = 1;
			bflwarning("x4_check: error: multiple drivers on port `%s'",
				   BehBus->NAME);
		}
		if (BehBus->TYPE == 'W') {
			Error = 1;
			bflwarning("x4_check: error: unsupported type (wor_bit) on port `%s'",
				   BehBus->NAME);
		}
	}
	for (BehBux = BehFigure->BEBUX; BehBux != 0; BehBux = BehBux->NEXT) {
		if (BehBux->TYPE == 'W') {
			Error = 1;
			bflwarning("x4_check: error: unsupported type (wor_bit) on signal `%s'",
				   BehBux->NAME);
		}
	}
	if (Error != 0)
		bflerror(1, "x4_Check: aborting ...");
}

/*----------------------------------------------------------------------*/
/*                                x4_cost                               */
/*----------------------------------------------------------------------*/

void 
x4_cost(fpm_expr_t * Expr, long * Count, long * Depth)
{
	bddnode *Node = Expr->BDD;
	chain_list *Support = x4_cost_rec(Node, Count, Depth);
	if ((Support != NULL) &&
	    (Support->NEXT != NULL || X4_IS_INVERTED(Node->MARK))) {

		bddnode *NodeInv = decbddrefext(applybddnodenot(0, Node));

		*Depth += 1;
		*Count += 1;

		X4_SET_MAPPED(Node->MARK);
		addauthelem(x4_depth_hash, (char *)Node, *Depth);

		X4_SET_MAPPED(NodeInv->MARK);
		X4_SET_INVERTED(NodeInv->MARK);
	}
	freechain(Support);
}

void
x4_clear(fpm_atom_t * Atom)
{
	bddvar MaxVar;
	bddindexnode *IndexNode;
	bddindex *VarToIndex;
	bddvar Var;
	bddhnodetable *NodeTable;
	long TableSize;
	long HashIndex;
	bddnode *HashNode;

	MaxVar     = FpmUser->NETWORK->BDD_SYSTEM->NUMBER_VAR;
	IndexNode  = FpmUser->NETWORK->BDD_SYSTEM->INDEX_NODE;
	VarToIndex = FpmUser->NETWORK->BDD_SYSTEM->VAR_TO_INDEX;

	for (Var = 0; Var < MaxVar; ++Var) {
		NodeTable = IndexNode[VarToIndex[Var]];
		TableSize = NodeTable->TABLE_SIZE;
		for (HashIndex = 0; HashIndex < TableSize; HashIndex++) {
			HashNode = NodeTable->TABLE[HashIndex];
			if ((HashNode != BDD_HASH_NODE_EMPTY) && (HashNode != BDD_HASH_NODE_DELETED)) {
				HashNode->MARK = 0;
			}
		}
	}
	resetauthtable(x4_depth_hash);
}

/*----------------------------------------------------------------------*/
/*            ablexpr *x4_mapp(bddnode *Node, int CreateAux)            */
/*----------------------------------------------------------------------*/

ablexpr *
x4_mapp(bddnode * Node, int CreateAux)
{
	chain_list *Support;
	ablexpr *Expr;

	Support = x4_mapp_rec(Node, &Expr, CreateAux);
	freechain(Support);

	if (!ABL_ATOM(Expr)) {
		if (CreateAux == 1) {
			/*
			 * Note: En cas de simplification par don't care dans
			 * x4_mapp_rec, il est possible que node ne soit pas le bon !!!
			 * (en fait, il n'y a pas correspondance entre le noeud bdd
			 * et l'expression.
			 *      On vas alors cree un CLB F alors qu'un H est possible
			 * (voir evalue comme tel par la fonction de cout ?
			 */
			freechain(x4_mapp_force(Node, &Expr));
		} else {
			X4_CLB_F++;
		}
	}
	return simpablexpr(Expr);
}

void 
x4_report()
{
	printf("   + Final number of Lut F: %d\n", X4_CLB_F);
	printf("   + Final number of Lut H: %d\n", X4_CLB_H);
}

void
x4_save()
{
	befig_list *BehFigure;
	int IobMode;

	BehFigure = FpmUser->BEFIG;
	IobMode = FpmUser->IOB_MODE;
	xnf_drive(BehFigure, IobMode);
}
