#ifndef __PBin_h
#define __PBin_h

#include <iostream>
#include <fstream>
#include <list>
#include "PSubRow.h"

class PToPlaceIns;

class PBin : public PContainer{
    friend class PSubRow;

  public:
    typedef list<PToPlaceIns*> PToPlaceInss;

  private:
    PSubRow*		_subRow;
    double		Capa;   	// Objective Occupation of the bin
    double		Size;   	// Sum of instances widths
    PToPlaceInss	_toPlaceInss;  	// Instances of bin.
    PPos		Pos;		// Position of the center of the bin
    unsigned		_nHits;

  public:
			PBin();
    
    void		Init(const PBBox NewBBox, const double NewCapacity, PSubRow &newsubrow);
    
    PSubRow*		GetSubRow() const	{ return _subRow; }
    bool		GetOrientation() const	{ return _subRow->GetOrientation(); }
    double		GetCapa() const        	{ return Capa; }
    double		GetSize() const        	{ return Size; }
    PToPlaceInss&	GetToPlaceInss()       	{ return _toPlaceInss; }
    unsigned		GetNIns() const		{ return _toPlaceInss.size(); }
    PPos		GetPos() const          { return Pos; }
    void		IncrNbHits();

    void		AddSize(const double Value) { Size += Value; _subRow->AddSize(Value); }

    bool		UnderOccupied(const double Margin) const;
    void		AddIns(PToPlaceIns *Ins);
    void		RemoveIns(PToPlaceIns *Ins);

    ostream&		Print(ostream& os) const;
    ofstream&		Plot(ofstream& out) const;
    ofstream&		PlotLabel(ofstream& out, unsigned TotalMoves) const;
};
#endif /* __PBin_h */
