#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>

#include MUT_H
#include MLO_H
#include MLU_H
#include MPH_H
#include MPU_H
#include "ocr.h"
#include "ocrWRoutingDataBase.h"
#include "ocrWindow.h"
#include "getOption.h"
#include "display.h"

extern ocrNaturalInt g_OptLayer;
extern ocrNaturalInt g_OptOrder;

/**
 * Gestion de la ligne de commande
**/
ocrOption *
getOption (int argc, char **argv)
{
  int c;
  ocrOption *l_pOcrOption;

  l_pOcrOption = (ocrOption *) mbkalloc (sizeof (ocrOption));
  l_pOcrOption->LEVEL = INFO;
  l_pOcrOption->ORDER = OCR_NORM;
  l_pOcrOption->WINDOW = 1;
  l_pOcrOption->PRIORITY = 0;

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
        {"od", 0, 0, 'o'},
        {"prio", 0, 0, 'p'},
        {"rr", 0, 0, 'r'},
        {"layer", 1, 0, 'l'},
        {"verbose", 0, 0, 'v'},
        {"debug", 0, 0, 'd'},
        {"window", 0, 0, 'w'},
        {0, 0, 0, 0}
      };

      c = getopt_long_only (argc, argv, "l:vdorw:",
                            long_options, &option_index);
      if (c == -1)
        break;

      switch (c)
        {
        case 'v':
          l_pOcrOption->LEVEL = VERBOSE;
          break;

        case 'd':
          l_pOcrOption->LEVEL = DEBUG;
          break;

        case 'o':
          l_pOcrOption->ORDER |= OCR_ODYN;
          break;

        case 'r':
          l_pOcrOption->ORDER |= OCR_RIPUP;
          break;

        case 'p':
          l_pOcrOption->PRIORITY = 1;
          break;

        case 'l':
          g_OptLayer = atoi (optarg);
          if (g_OptLayer < 2)
            {
              puts ("option -l n : n >= 2");
              exit (1);
            }
          break;

        case 'w':
          l_pOcrOption->WINDOW = atoi (optarg);
          break;

        case '?':
          break;

        default:
          printf ("?? getopt returned character code 0%o ??\n", c);
        }
    }
  return l_pOcrOption;
}
