
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: prb_addprbevt.c					*/
/* date		: May 18 1994						*/
/* version	: v100							*/
/* authors	: Julien DUNOYER 					*/
/* content	: low-level prb function				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function	: prb_addprbevt						*/
/* description	: create a PRBEVT (input-scannable event) structure at 	*/
/*		  the top of a list					*/
/* called func.	: mbkalloc						*/
/* ###--------------------------------------------------------------### */

struct prbevt *prb_addprbevt (lastprbevt,name,discval,densval,probval,mode,type)

struct prbevt   *lastprbevt;	/* pointer on the last prbevt structure	*/
char		*name;		/* input's name				*/
float		 discval;	/* disconnect value			*/
float		 densval;	/* density value			*/
float		 probval;	/* probability value			*/
char		 mode;		/* input, scannable or clock		*/
char		 type;		/* used by linker			*/

  {
  struct prbevt *ptevt;

  ptevt          = (struct prbevt *) mbkalloc (sizeof(struct prbevt));
  ptevt->NAME    = namealloc(name);
  ptevt->MODE    = mode;
  ptevt->TYPE    = type;
  ptevt->SIG     = NULL;
  ptevt->NEXT    = lastprbevt;
  
  ptevt->VALUE   = (struct prbval *) mbkalloc (sizeof(struct prbval));
  ptevt->VALUE->DISCVAL = discval;
  ptevt->VALUE->DENSVAL = densval;
  ptevt->VALUE->PROBVAL = probval;

  return (ptevt);
  }
