
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: prb_addprbini.c					*/
/* date		: May 18 1994						*/
/* version	: v100							*/
/* authors	: Julien DUNOYER					*/
/* content	: low-level prb function				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function	: prb_addprbini						*/
/* description	: create a PRBINI (unscannable register) structure	*/
/*		  at the top of a list					*/
/* called func.	: namealloc, mbkalloc					*/
/* ###--------------------------------------------------------------### */

struct prbini *prb_addprbini (lastprbini, name)

struct prbini *lastprbini;	/* pointer on the last prbini structure	*/
char         *name;		/* register's name			*/

  {
  struct prbini *ptini;

  name         = namealloc (name);

  ptini        = (struct prbini *) mbkalloc (sizeof(struct prbini));
  ptini->NAME  = name;
  ptini->NEXT  = lastprbini;

  return (ptini);
  }
