
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: prb_addpaseq.c					*/
/* date		: May 18 1994						*/
/* version	: v100							*/
/* authors	: Julien DUNOYER					*/
/* content	: low-level prb function				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function	: prb_addprbseq						*/
/* description	: create an empty PRBSEQ structure at the top of a list	*/
/* called func.	: mbkalloc						*/
/* ###--------------------------------------------------------------### */

struct prbseq *prb_addprbseq (name)

char 		*name;		/* name of the prbseq structure */

  {
  struct prbseq *ptseq;

  ptseq           = (struct prbseq *) mbkalloc (sizeof(struct prbseq));

  ptseq->NAME     = (char *) namealloc (name);
  ptseq->PRBINI   = NULL;
  ptseq->PRBINO   = NULL;
  ptseq->PRBEVT   = NULL;

  ptseq->PROBVAL  = (float) DEF_PRB_DEFPROB;
  ptseq->DISCVAL  = (float) DEF_PRB_DEFDISC;
  ptseq->DENSVAL  = (float) DEF_PRB_DEFDENS;
  ptseq->SCANVAL  = DEF_PRB_UNSCAN;

  ptseq->FLAG     = DEF_PRB_FLAG_NUL;
  ptseq->ERRFLG   = 0;

  ptseq->NEXT     = PRB_HEAD_PRBSEQ;
  PRB_HEAD_PRBSEQ = ptseq;

  return (ptseq);
  }
