
/* ###--------------------------------------------------------------### */
/* 									*/
/* file		: prb_freprbseq.c					*/
/* date		: May 18 1994						*/
/* version	: v100							*/
/* authors	: Julien DUNOYER					*/
/* content	: low-level prb function				*/
/*									*/
/* ###--------------------------------------------------------------### */

#include MUT_H
#include PRB_H

/* ###--------------------------------------------------------------### */
/* function	: prb_freprbseq						*/
/* description	: release the PRBSEQ (sequence) data base		*/
/* called func.	: mbkfree, prb_freprbini, prb_freprbevt, prb_freprbino  */
/* ###--------------------------------------------------------------### */

void prb_freprbseq ()

  {
  struct prbseq *ptseq;

        /* ###------------------------------------------------------### */
        /*    for each object of the list delete the object itself      */
        /*    and its attached lists				        */
        /* ###------------------------------------------------------### */

  while (PRB_HEAD_PRBSEQ != NULL)
    {
    ptseq     = PRB_HEAD_PRBSEQ;
    PRB_HEAD_PRBSEQ = PRB_HEAD_PRBSEQ->NEXT;

    prb_freprbini   (ptseq->PRBINI);
    prb_freprbevt   (ptseq->PRBEVT);
    prb_freprbino   (ptseq->PRBINO);

    mbkfree (ptseq);
    }
  }
