/* ###--------------------------------------------------------------### */
/*									*/
/* file		: prb_getprbseq.c					*/
/* date		: Jun  1 1994						*/
/* version	: v1.00							*/
/* author	: DUNOYER julien					*/
/* description	: This file contains only one function to get a prb	*/
/*		  sequence in memory				 	*/
/*		  prb_loadcompare  , prb_writecompare			*/
/*		  prb_storecompare , prb_statistics			*/
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include <sys/time.h>

#include MUT_H
#include LOG_H
#include MLO_H
#include "beh.h"
#include "bhl.h"
#include PRB_H
#include GSS_H

/* ###--------------------------------------------------------------### */
/*                       defines                                        */
/*                       static variables declaration                   */
/*                       externals                                      */
/* ###--------------------------------------------------------------### */

/* ###--------------------------------------------------------------### */
/* function	: prb_getprbseq						*/
/* description	: get a probability sequence from the prb data base	*/
/*		  prb_getprbseq returns the prbseq called seqname with	*/
/*		  the  warranty  that  the  expected information is	*/
/*		  present and unique in memory.				*/
/* called func.	: mbkfopen  , prb_error , prb_parser			*/
/* ###--------------------------------------------------------------### */

struct prbseq *prb_getprbseq (seqname)

char          *seqname;		/* name of prbseq to be found or parsed	*/

  {
  FILE          *fp         = NULL;
  struct prbseq *pt_prbseq  = NULL;

  seqname = namealloc (seqname);

  for (pt_prbseq = PRB_HEAD_PRBSEQ; pt_prbseq; pt_prbseq = pt_prbseq->NEXT)
    {
    if (pt_prbseq->NAME == seqname)
      {
      break;
      }
    }

        /* ###------------------------------------------------------### */
        /*   If this sequence doesn't exist => prb_parser		*/
        /* ###------------------------------------------------------### */

  if (pt_prbseq == NULL)
    {
    fp = mbkfopen (seqname, PRB_IN_SUFFIX, READ_TEXT);

    if (fp == NULL)
      {
      prb_error (3, seqname, 0.0, ' ', 0);
      exit (1);
      }

    pt_prbseq = prb_parser (fp, seqname);
    fclose (fp);
    }

  return (pt_prbseq);
  }

