/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - CMOS Cells Compiler
 * Date    : 1991,92
 * Author  : Nathalie Dictus
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */




#ident "$Id: c4_decomp_latch1.c,v 1.2 2000/11/07 16:15:17 czo Exp $"

/*****************************************************/
/*****  Fonction permettant de creer une Befig.  *****/
/*** Ce fichier est genere par ~luc/luc/GEN/gen    ***/
/**** qui prend en entree un .vbe et qui le parse ****/
/****            batch macrogenere                ****/
/***    fichier compile : latch1.vbe    ***/
/**********************************************/

#include <stdio.h>
#include <stdlib.h>

#include MUT_H
#include LOG_H
#include BEH_H

befig_list *
latch1 ()
{
  befig_list *befigAux;
  chain_list *abl;
  begen_list *genAux = NULL;
  int *pentier;
  biabl_list *biabl = NULL;
  chain_list *cndabl = NULL;
  chain_list *valabl = NULL;
  befigAux = beh_addbefig (NULL, namealloc ("latch1"));
  befigAux->BERIN = beh_addberin (befigAux->BERIN, namealloc ("mpx_s"));
  befigAux->BERIN = beh_addberin (befigAux->BERIN, namealloc ("vss"));
  befigAux->BERIN = beh_addberin (befigAux->BERIN, namealloc ("vdd"));
  befigAux->BERIN = beh_addberin (befigAux->BERIN, namealloc ("l"));
  befigAux->BERIN = beh_addberin (befigAux->BERIN, namealloc ("i"));
  befigAux->BEPOR = beh_addbepor (befigAux->BEPOR, namealloc ("vss"), 'I', 'B');
  befigAux->BEPOR = beh_addbepor (befigAux->BEPOR, namealloc ("vdd"), 'I', 'B');
  befigAux->BEPOR = beh_addbepor (befigAux->BEPOR, namealloc ("t"), 'O', 'B');
  befigAux->BEPOR = beh_addbepor (befigAux->BEPOR, namealloc ("l"), 'I', 'B');
  befigAux->BEPOR = beh_addbepor (befigAux->BEPOR, namealloc ("i"), 'I', 'B');
  befigAux->BEPOR = (bepor_list *) reverse ((chain_list *) befigAux->BEPOR);
  abl = charToExpr ("mpx_s");
  befigAux->BEOUT = beh_addbeout (befigAux->BEOUT, namealloc ("t"), abl, NULL);
  valabl = charToExpr ("i");
  cndabl = charToExpr ("l");
  biabl = beh_addbiabl (biabl, "label0", cndabl, valabl);
  biabl->USER = NULL;
  befigAux->BEREG = beh_addbereg (befigAux->BEREG, namealloc ("mpx_s"), biabl, NULL);
  pentier = (int *) mbkalloc (sizeof (int));
  *pentier = 21;
  genAux = beh_addbegen (genAux, "cin_l", "natural", (void *) pentier);
  pentier = (int *) mbkalloc (sizeof (int));
  *pentier = 56;
  genAux = beh_addbegen (genAux, "cin_i", "natural", (void *) pentier);
  pentier = (int *) mbkalloc (sizeof (int));
  *pentier = 1200;
  genAux = beh_addbegen (genAux, "rdown", "natural", (void *) pentier);
  pentier = (int *) mbkalloc (sizeof (int));
  *pentier = 1554;
  genAux = beh_addbegen (genAux, "rup", "natural", (void *) pentier);
  pentier = (int *) mbkalloc (sizeof (int));
  *pentier = 1260;
  genAux = beh_addbegen (genAux, "area", "natural", (void *) pentier);
  befigAux->BEGEN = genAux;
  befigAux->CIRCUI = NULL;
  befigAux->NEXT = NULL;
  abl = charToExpr ("(and vdd (not vss))");
  befigAux->BEMSG = beh_addbemsg (befigAux->BEMSG, NULL, 'W', "\"power supply is missing on latch1\"", abl, NULL);

  return befigAux;
}
